part of '../export.dart';

/// TODO replace with Tuples in dartz when tuple6-tuple20 land
class TwoWave<A, B> {
  final Wave<A> a;
  final Wave<B> b;

  const TwoWave(this.a, this.b);

  ThreeWave<A, B, Z> and<Z>(Wave<Z> other) => ThreeWave(a, b, other);

  Wave<Z> latest<Z>(Z Function(A, B) map) => Wave.combineLatest2(a, b, map);
}

class ThreeWave<A, B, C> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;

  const ThreeWave(this.a, this.b, this.c);

  FourWave<A, B, C, Z> and<Z>(Wave<Z> other) => FourWave(a, b, c, other);

  Wave<Z> latest<Z>(Z Function(A, B, C) map) =>
      Wave.combineLatest3(a, b, c, map);
}

class FourWave<A, B, C, D> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;

  const FourWave(this.a, this.b, this.c, this.d);

  FiveWave<A, B, C, D, Z> and<Z>(Wave<Z> other) => FiveWave(a, b, c, d, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D) map) =>
      Wave.combineLatest4(a, b, c, d, map);
}

class FiveWave<A, B, C, D, E> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;

  const FiveWave(this.a, this.b, this.c, this.d, this.e);

  SixWave<A, B, C, D, E, Z> and<Z>(Wave<Z> other) =>
      SixWave(a, b, c, d, e, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E) map) =>
      Wave.combineLatest5(a, b, c, d, e, map);
}

class SixWave<A, B, C, D, E, F> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;

  const SixWave(this.a, this.b, this.c, this.d, this.e, this.f);

  SevenWave<A, B, C, D, E, F, Z> and<Z>(Wave<Z> other) =>
      SevenWave(
          a,
          b,
          c,
          d,
          e,
          f,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F) map) =>
      Wave.combineLatest6(
          a,
          b,
          c,
          d,
          e,
          f,
          map);
}

class SevenWave<A, B, C, D, E, F, G> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;

  const SevenWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g);

  EightWave<A, B, C, D, E, F, G, Z> and<Z>(Wave<Z> other) =>
      EightWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G) map) =>
      Wave.combineLatest7(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          map);
}

class EightWave<A, B, C, D, E, F, G, H> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;

  const EightWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g,
      this.h);

  NineWave<A, B, C, D, E, F, G, H, Z> and<Z>(Wave<Z> other) =>
      NineWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H) map) =>
      Wave.combineLatest8(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          map);
}

class NineWave<A, B, C, D, E, F, G, H, I> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;
  final Wave<I> i;

  const NineWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g, this.h, this.i);

  TenWave<A, B, C, D, E, F, G, H, I, Z> and<Z>(Wave<Z> other) =>
      TenWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I) map) =>
      Wave.combineLatest9(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          map);
}

class TenWave<A, B, C, D, E, F, G, H, I, J> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;
  final Wave<I> i;
  final Wave<J> j;

  const TenWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g, this.h, this.i, this.j);

  ElevenWave<A, B, C, D, E, F, G, H, I, J, Z> and<Z>(Wave<Z> other) =>
      ElevenWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J) map) =>
      Wave.combineLatest10(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          map);
}

class ElevenWave<A, B, C, D, E, F, G, H, I, J, K> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;
  final Wave<I> i;
  final Wave<J> j;
  final Wave<K> k;

  const ElevenWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g, this.h, this.i, this.j, this.k);

  TwelveWave<A, B, C, D, E, F, G, H, I, J, K, Z> and<Z>(Wave<Z> other) =>
      TwelveWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K) map) =>
      Wave.combineLatest11(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          map);
}

class TwelveWave<A, B, C, D, E, F, G, H, I, J, K, L> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;
  final Wave<I> i;
  final Wave<J> j;
  final Wave<K> k;
  final Wave<L> l;

  const TwelveWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g, this.h, this.i, this.j, this.k, this.l);

  ThirteenWave<A, B, C, D, E, F, G, H, I, J, K, L, Z> and<Z>(Wave<Z> other) =>
      ThirteenWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L) map) =>
      Wave.combineLatest12(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          map);
}

class ThirteenWave<A, B, C, D, E, F, G, H, I, J, K, L, M> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;
  final Wave<I> i;
  final Wave<J> j;
  final Wave<K> k;
  final Wave<L> l;
  final Wave<M> m;

  const ThirteenWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g, this.h, this.i, this.j, this.k, this.l,
      this.m);

  FourteenWave<A, B, C, D, E, F, G, H, I, J, K, L, M, Z> and<Z>(Wave<Z> other) =>
      FourteenWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M) map) =>
      Wave.combineLatest13(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          map);
}

class FourteenWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;
  final Wave<I> i;
  final Wave<J> j;
  final Wave<K> k;
  final Wave<L> l;
  final Wave<M> m;
  final Wave<N> n;

  const FourteenWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g, this.h, this.i, this.j, this.k, this.l,
      this.m, this.n);

  FifteenWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N, Z> and<Z>(Wave<Z> other) =>
      FifteenWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N) map) =>
      Wave.combineLatest14(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          map);
}

class FifteenWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;
  final Wave<I> i;
  final Wave<J> j;
  final Wave<K> k;
  final Wave<L> l;
  final Wave<M> m;
  final Wave<N> n;
  final Wave<O> o;

  const FifteenWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g, this.h, this.i, this.j, this.k, this.l,
      this.m, this.n, this.o);

  SixteenWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, Z> and<Z>(Wave<Z> other) =>
      SixteenWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          o,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O) map) =>
      Wave.combineLatest15(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          o,
          map);
}

class SixteenWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;
  final Wave<I> i;
  final Wave<J> j;
  final Wave<K> k;
  final Wave<L> l;
  final Wave<M> m;
  final Wave<N> n;
  final Wave<O> o;
  final Wave<P> p;

  const SixteenWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g, this.h, this.i, this.j, this.k, this.l,
      this.m, this.n, this.o, this.p);

  SeventeenWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Z> and<Z>(Wave<Z> other) =>
      SeventeenWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          o,
          p,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P) map) =>
      Wave.combineLatest16(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          o,
          p,
          map);
}

class SeventeenWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;
  final Wave<I> i;
  final Wave<J> j;
  final Wave<K> k;
  final Wave<L> l;
  final Wave<M> m;
  final Wave<N> n;
  final Wave<O> o;
  final Wave<P> p;
  final Wave<Q> q;

  const SeventeenWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g, this.h, this.i, this.j, this.k, this.l,
      this.m, this.n, this.o, this.p, this.q);

  EighteenWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, Z> and<Z>(Wave<Z> other) =>
      EighteenWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          o,
          p,
          q,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q) map) =>
      Wave.combineLatest17(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          o,
          p,
          q,
          map);
}

class EighteenWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;
  final Wave<I> i;
  final Wave<J> j;
  final Wave<K> k;
  final Wave<L> l;
  final Wave<M> m;
  final Wave<N> n;
  final Wave<O> o;
  final Wave<P> p;
  final Wave<Q> q;
  final Wave<R> r;

  const EighteenWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g, this.h, this.i, this.j, this.k, this.l,
      this.m, this.n, this.o, this.p, this.q, this.r);

  NineteenWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, Z> and<Z>(Wave<Z> other) =>
      NineteenWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          o,
          p,
          q,
          r,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R) map) =>
      Wave.combineLatest18(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          o,
          p,
          q,
          r,
          map);
}

class NineteenWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;
  final Wave<I> i;
  final Wave<J> j;
  final Wave<K> k;
  final Wave<L> l;
  final Wave<M> m;
  final Wave<N> n;
  final Wave<O> o;
  final Wave<P> p;
  final Wave<Q> q;
  final Wave<R> r;
  final Wave<S> s;

  const NineteenWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g, this.h, this.i, this.j, this.k, this.l,
      this.m, this.n, this.o, this.p, this.q, this.r, this.s);

  TwentyWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, Z> and<Z>(Wave<Z> other) =>
      TwentyWave(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          o,
          p,
          q,
          r,
          s,
          other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S) map) =>
      Wave.combineLatest19(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          o,
          p,
          q,
          r,
          s,
          map);
}

class TwentyWave<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T> {
  final Wave<A> a;
  final Wave<B> b;
  final Wave<C> c;
  final Wave<D> d;
  final Wave<E> e;
  final Wave<F> f;
  final Wave<G> g;
  final Wave<H> h;
  final Wave<I> i;
  final Wave<J> j;
  final Wave<K> k;
  final Wave<L> l;
  final Wave<M> m;
  final Wave<N> n;
  final Wave<O> o;
  final Wave<P> p;
  final Wave<Q> q;
  final Wave<R> r;
  final Wave<S> s;
  final Wave<T> t;

  const TwentyWave(this.a, this.b, this.c, this.d, this.e, this.f, this.g, this.h, this.i, this.j, this.k, this.l,
      this.m, this.n, this.o, this.p, this.q, this.r, this.s, this.t);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T) map) =>
      Wave.combineLatest20(
          a,
          b,
          c,
          d,
          e,
          f,
          g,
          h,
          i,
          j,
          k,
          l,
          m,
          n,
          o,
          p,
          q,
          r,
          s,
          t,
          map);
}
